Main Page Namespace List Class Hierarchy Compound List File List Namespace Members Compound Members File Members Related Pages

# wkgl Namespace Reference

## Compounds
class | AbstractButton
| This class implements a generic button. More...
class | AbstractEdit
| This class implements common edit control features. More...
class | AppBar
| This class allows you to place an application toolbar on the desktop. More...
class | Button
| This class implements a push-button. More...
class | ButtonGroup
class | CallBack
| Inherit from this class to use a callback function in your class. More...
class | CheckBox
| This class implements a check box. More...
struct | CHILDCOMPONENT
| Represents a child component of this component. Used by clisteners to store the child components that wish to receive events. More...
class | ComboBox
| This class implements a generic combo box. More...
class | Component
| This is the base class for all components in the MigLib. This class defines how events are fired, and how components are shown. More...
class | Control
class | Cursor
| A class that represents a cursor. More...
class | Dialog
| This class implements a dialog box. More...
class | DropTarget
| This class allows a component to become a drop target. More...
struct | FORMATNODE
| Nodes used for the doubly linked list that is used to test formats. More...
class | Edit
| This class implements a single line edit control. More...
class | Icon
| A class that represents an icon. More...
struct | LAYOUT_INFO
| \breif This struct contains information used to layout a component. More...
class | LayoutManager
| This class implements a layout-able area inside a control. More...
class | ListBox
| This class implements a generic list box. More...
class | Menu
| This class represents a drop-down menu or sub-menu. More...
class | MenuBar
| This class allows you to place a menu bar on a window. More...
class | MenuItem
| A single item in a menu. More...
struct | MENUITEM
| Used to send events to the appropriate callback. More...
class | MultilineEdit
| This class implements a multiple line edit control. More...
class | PopupMenu
| This class allows you to display a popup menu. \Author Micheal Nooner. A popup menu is usually shown when the user right clicks in a specific area of a window. More...
class | RadioButton
| This class implements a radio button. More...
struct | REGCOMPONENT
| A Registered component. Used by GlobalWinProc to figure out which FireEvent to call. More...
class | Socket
| This class allows you to send information and recieve information using a TCP/IP connection. More...
class | StateButton
| This class implements a state button. More...
class | Static
| This class implements a static control. More...
class | String
| An implementation of a unicode string class. More...
struct | tag_DROPTARGET_DATA
| Passed to event handlers. This struct encaplualtes all the data needed to handle drop events. More...
class | Thread
| This class allows you to perform multithreading. More...
class | ThreadGroup
| This class allows you to perform actions on a group of threads. More...
class | TrayIcon
| Creates, Modifies, Removes icons from the system tray. More...
class | Window
| This class implements a generic window. More...
## Typedefs
typedef BOOL(* | COMCALLBACK )(Component *com, UINT message, WPARAM wParam, LPARAM lParam)
| Defines the type used to in callback functions.
typedef wkgl::tag_DROPTARGET_DATA | DROPTARGET_DATA
| Passed to event handlers. This struct encaplualtes all the data needed to handle drop events.
typedef wkgl::tag_DROPTARGET_DATA * | LPDROPTARGET_DATA
| Passed to event handlers. This struct encaplualtes all the data needed to handle drop events.
typedef HRESULT(* | DROPTARGET_CALLBACK )(Component *com, DWORD message, LPDROPTARGET_DATA params, DWORD *effect)
| The prototype for the callback function used with drop targets.
typedef RECT(* | LAYOUTFUNC )(Control **, int, LAYOUT_INFO)
typedef BOOL(* | MENUCALLBACK )(MenuItem *item, UINT message)
| Prototype of the callback used by menus.
typedef void(* | RUNNABLE )(void *param)
| Prototype of the functions that are executed by threads.
## Functions
void | appBarCallback (HWND hwndAccessBar, UINT uNotifyMsg, LPARAM lParam)
void | appBarSetPosition (APPBARDATA &adata, UINT edge, RECT *rect)
BOOL | setButtons (Component *com, UINT message, WPARAM wParam, LPARAM lParam)
| Sets a the new button, and unsets the previous one.
char * | showOpenFileDlg (Component *parent, const char *default_dir, const char *filter, DWORD deffilter_index, DWORD flags)
| Displays an open file dialog and returns the full file name the user selected.
char * | showSaveFileDlg (Component *parent, const char *default_dir, const char *filter, DWORD deffilter_index, DWORD flags)
| Displays a save file dialog and returns the full file name the user selected.
void | showErrorDlg (Component *parent, const char *text, const char *caption, DWORD style)
| Displays an error message box with a style of MB_OK | MB_ICONERROR.
int | showMessageBox (Component *parent, const char *text, const char *caption, DWORD style)
| Displays a general message box with a style of MB_OK.
LRESULT CALLBACK | globalProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
| Is used to process all the callback functions.
INT _stdcall | dialogProc (HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
| The default callback used to process dialog events.
RECT | NoLayout (Control **comps, int ncomps, LAYOUT_INFO info)
RECT | FlowLayoutL (Control **comps, int ncomps, LAYOUT_INFO info)
RECT | FlowLayoutR (Control **comps, int ncomps, LAYOUT_INFO info)
RECT | FormLayout (Control **comps, int ncomps, LAYOUT_INFO info)
WCHAR * | ctowc (const char *string)
| Converts a char* to a WCHAR* (unicode).
WCHAR * | cntowc (const char *string, long len)
| Converts n characters of a char* to a WCHAR* (unicode).
char * | wctoc (WCHAR *string)
DWORD WINAPI | ThreadProc (LPVOID lpParam)
char * | wctoc (const WCHAR *string)
| Converts a WCHAR* (unicode) to a char*.
## Variables
HINSTANCE | gInstance
| The current instance, passed to WinMain.
HINSTANCE | gPrevInstance
| The previous instance, passed to WinMain.
String | gCmdLine
| The command line, passed to WinMain.
INT | gCmdShow
| The show command, passed to WinMain.

## Typedef Documentation

typedef BOOL(* wkgl::COMCALLBACK)( Component* com, UINT message, WPARAM wParam, LPARAM lParam )

  | Defines the type used to in callback functions. Parameters:
  com | A pointer to the component that generated the message.
  message | The windows integer event.
  wParam | contain information about the event, see windows docs.
  lParam | contain information about the event, see windows docs.
Returns: TRUE if the event was handled, FALSE otherwise.

typedef HRESULT(* wkgl::DROPTARGET_CALLBACK)( Component* com, DWORD message, LPDROPTARGET_DATA params, DWORD* effect )

  | The prototype for the callback function used with drop targets. Parameters:
  com | The component creating the event.
  message | Either DTM_ENTER, DTM_LEAVE, DTM_OVER, or DTM_DROP.
  params | See DROPTARGET_DATA structure.
  effect | Either DROPEFFECT_NONE, DROPEFFECT_COPY, DROPEFFECT_MOVE, DROPEFFECT_LINK, or DROPEFFECT_SCROLL see DROPEFFECT in win docs.

typedef struct wkgl::tag_DROPTARGET_DATA wkgl::DROPTARGET_DATA

| Passed to event handlers. This struct encaplualtes all the data needed to handle drop events.

typedef RECT(* wkgl::LAYOUTFUNC)(Control**, int, LAYOUT_INFO )

typedef struct wkgl::tag_DROPTARGET_DATA * wkgl::LPDROPTARGET_DATA

| Passed to event handlers. This struct encaplualtes all the data needed to handle drop events.

typedef BOOL(* wkgl::MENUCALLBACK)( MenuItem* item, UINT message )

  | Prototype of the callback used by menus. Parameters:
  item | The item that generated the message.
  message | The messaged generated by the item.

typedef void(* wkgl::RUNNABLE)( void *param )

  | Prototype of the functions that are executed by threads. Parameters:
  param | This parameter can be a pointer to anything you wish, this allows you to pass information to your runnable function.

## Function Documentation

void appBarCallback | ( | HWND | hwndAccessBar,
|  | UINT | uNotifyMsg,
|  | LPARAM | lParam
| ) |

void appBarSetPosition | ( | APPBARDATA & | adata,
|  | UINT | edge = NULL,
|  | RECT * | rect = NULL
| ) |

WCHAR * wkgl::cntowc | ( | const char * | string,
|  | long | len
| ) |

  | Converts n characters of a char* to a WCHAR* (unicode). Parameters:
  string | The array to convert.
  len | The number of characters to convert.
Returns: A pointer a new array holding the converted characters.

WCHAR * wkgl::ctowc | ( | const char * | string | ) |

  | Converts a char* to a WCHAR* (unicode). Parameters:
  string | The array to convert.
Returns: A pointer a new array holding the converted characters.

INT _stdcall dialogProc | ( | HWND | hwndDlg,
|  | UINT | uMsg,
|  | WPARAM | wParam,
|  | LPARAM | lParam
| ) |

  | The default callback used to process dialog events. Parameters:
  hwndDlg | handle to dialog box
  uMsg | message
  wParam | first message parameter
  lParam | second message parameter

RECT wkgl::FlowLayoutL | ( | Control ** | comps,
|  | int | ncomps,
|  | LAYOUT_INFO | info
| ) |

RECT wkgl::FlowLayoutR | ( | Control ** | comps,
|  | int | ncomps,
|  | LAYOUT_INFO | info
| ) |

RECT wkgl::FormLayout | ( | Control ** | comps,
|  | int | ncomps,
|  | LAYOUT_INFO | info
| ) |

LRESULT CALLBACK globalProc | ( | HWND | hwnd,
|  | UINT | message,
|  | WPARAM | wParam,
|  | LPARAM | lParam
| ) |

  | Is used to process all the callback functions. Parameters:
  hwnd | the window handle to the window the events go to
  message | the windows message to pass to the callback
  wParam | the submessage (see windows docs).
  lParam | the subparameter (see windows docs).
Returns: what the appropriate component's FireEvent() method returns otherwise if returns what DefWindowProc() returns. See also: Component::FireEvents

RECT wkgl::NoLayout | ( | Control ** | comps,
|  | int | ncomps,
|  | LAYOUT_INFO | info
| ) |

BOOL setButtons | ( | Component * | com,
|  | UINT | message,
|  | WPARAM | wParam,
|  | LPARAM | lParam
| ) |

| Sets a the new button, and unsets the previous one.

void wkgl::showErrorDlg | ( | Component * | parent,
|  | const char * | text,
|  | const char * | caption = NULL,
|  | DWORD | style = MB_OK | MB_ICONERROR
| ) |

  | Displays an error message box with a style of MB_OK | MB_ICONERROR. Parameters:
  parent | The parent component this message box is modal against.
  text | The message to display.
  caption | The text to display in the title bar.
  style | see MessageBox() in the windows docs.

int wkgl::showMessageBox | ( | Component * | parent,
|  | const char * | text,
|  | const char * | caption = NULL,
|  | DWORD | style = MB_OK
| ) |

  | Displays a general message box with a style of MB_OK. Parameters:
  parent | The parent component this message box is modal against.
  text | The message to display.
  caption | The text to display in the title bar.
  style | see MessageBox() in the windows docs.
Returns: Usually ID_OK for MB_OK style, other return values are used for other styles, see MessageBox() in the windows docs.

char * wkgl::showOpenFileDlg | ( | Component * | parent,
|  | const char * | default_dir = NULL,
|  | const char * | filter = NULL,
|  | DWORD | deffilter_index = 0,
|  | DWORD | flags = 0
| ) |

| Displays an open file dialog and returns the full file name the user selected. You should specify them as follows:
       char *my_filter = "Sample Files\0*.TXT;*.CPP;*.H\0All Files\0*.*\0\0";
  Notice that the description and its extentions are sperated by a null character. Also notice that extension lists are created by seperating each extension with a semicolon. Parameters:
  parent | The parent component this dialog is to be modal against.
  default_dir | A string indicating the directory the dialog is to start in.
  filter | Pointer to a buffer containing pairs of null-terminated filter strings.
  deffilter_index | The index of the defualt filter to use.
  flags | Flags to use with this dialog (see OPENFILENAME windows docs).
Returns: The path + filename + extension of the file selected or NULL if the user canceled the operation.

char * wkgl::showSaveFileDlg | ( | Component * | parent,
|  | const char * | default_dir = NULL,
|  | const char * | filter = NULL,
|  | DWORD | deffilter_index = 0,
|  | DWORD | flags = 0
| ) |

| Displays a save file dialog and returns the full file name the user selected. You should specify them as follows:
       char *my_filter = "Sample Files\0*.TXT;*.CPP;*.H\0All Files\0*.*\0\0";
  Notice that the description and its extentions are sperated by a null character. Also notice that extension lists are created by seperating each extension with a semicolon. Parameters:
  parent | The parent component this dialog is to be modal against.
  default_dir | A string indicating the directory the dialog is to start in.
  filter | Pointer to a buffer containing pairs of null-terminated filter strings.
  deffilter_index | The index of the defualt filter to use.
  flags | Flags to use with this dialog (see OPENFILENAME windows docs).
Returns: The path + filename + extension of the file selected or NULL if the user canceled the operation.

DWORD WINAPI ThreadProc | ( | LPVOID | lpParam | ) |

char* wctoc | ( | const WCHAR * | string | ) |

  | Converts a WCHAR* (unicode) to a char*. Parameters:
  string | The array to convert.
Returns: A pointer a new array holding the converted characters.

char* wctoc | ( | WCHAR * | string | ) |

## Variable Documentation

String wkgl::gCmdLine

| The command line, passed to WinMain.

INT wkgl::gCmdShow

| The show command, passed to WinMain.

HINSTANCE wkgl::gInstance

| The current instance, passed to WinMain.

HINSTANCE wkgl::gPrevInstance

| The previous instance, passed to WinMain.